ATOPCASE(4)

NAME
atopcase - Apple HID-over-SPI transport driver

SYNOPSIS
To compile this driver into the kernel, place the following lines in your kernel configuration file:

device atopcase
device intelspi
device spibus
device hidbus
device hkbd

Alternatively, to load the driver as a module at boot time, place the following line in loader.conf(5):

    atopcase_load="YES"
    hkbd_load="YES"

DESCRIPTION
The atopcase driver provides support for Human Interface Devices (HID) on Serial Peripheral Interface (SPI) buses on Apple Intel Macs.

HARDWARE
The atopcase driver supports the following MacBooks produced in 2015-2018 years:

•   Macbook8,1
•   Macbook9,1
•   Macbook10,1
•   MacbookPro11,4
•   MacbookPro12,1
•   MacbookPro13,1
•   MacbookPro13,2
•   MacbookPro13,3
•   MacbookPro14,1
•   MacbookPro14,2
•   MacbookPro14,3

SYSCTL VARIABLES
The following variables are available as both sysctl(8) variables and loader(8) tunables:

hw.hid.atopcase.debug
    Debug output level, where 0 is debugging disabled and larger values increase debug message verbosity. Default is 0.

FILES
/dev/backlight/atopcase0
    Keyboard backlight(8) device node.

SEE ALSO
acpi(4), loader.conf(5), backlight(8), loader(8)

HISTORY
The atopcase driver first appeared in FreeBSD 14.0.

AUTHORS
-nosplit The atopcase driver was originally written by Val Packett <val@packett.cool> and marginally improved upon by Vladimir Kondratyev <wulf@FreeBSD.org>.

This manual page was written by Vladimir Kondratyev <wulf@FreeBSD.org>.

BUGS
Device interrupts are not acknowledged on some hardware that results in interrupt storm. Installation of Darwin OSI in acpi(4) driver fixes the issue. To install Darwin OSI add following lines to loader.conf(5):

hw.acpi.install_interface="Darwin"

hw.acpi.remove_interface="Windows 2009, Windows 2012"